%define version_maj 3
%define version_min 1
%define version_rev 2
%define version_tag SP10
%define version_full %{version_maj}.%{version_min}.%{version_rev}.%{version_tag}

%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/jboss/jbossws/%{version_full}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

Summary:        JBoss Web Services
Name:           jbossws
Version:        %{version_maj}.%{version_min}.%{version_rev}
Release:        6.%{version_tag}.1%{?dist}
Epoch:          0
License:        LGPLv2+
Group:          Development/Java
URL:            http://labs.jboss.com/jbossws/
# svn export https://svn.jboss.org/repos/jbossws/stack/native/branches/jbossws-native-3.1.2.SP10
# (will become the tag below:)
# svn export https://svn.jboss.org/repos/jbossws/stack/native/tags/jbossws-native-3.1.2.SP10
# Exported revision 14665.
# tar czf jbossws-3.1.2.SP10-src.tar.gz jbossws-native-3.1.2.SP10
Source0:        %{name}-%{version_full}-src.tar.gz
Source1:        %{name}-component-info.xml
Source2:        %{name}-jpp-depmap.xml

#change Class-Path from jaxrpc-api.jar to jboss-jaxrpc-api_1.1_spec.jar
Patch0:		jbossws-native-client-manifest.patch

BuildRequires: codehaus-stax11-api >= 0:1.1.2
BuildRequires: glassfish-jaxb >= 0:2.1.9
BuildRequires: glassfish-jaxws >= 0:2.1.3
BuildRequires: glassfish-javamail
BuildRequires: jaxbintros >= 0:1.0.0
BuildRequires: jettison >= 0:1.0
BuildRequires: jakarta-commons-logging >= 0:1.1.1
BuildRequires: javassist >= 0:3.6.0
BuildRequires: jboss-jaxr >= 0:1.2.1
BuildRequires: jboss-parent >= 0:4.0
BuildRequires: jboss-javaee-poms >= 0:5.0.0
BuildRequires: jboss-ejb-3.0-api >= 0:5.0.0
BuildRequires: jboss-jms-1.1-api >= 0:5.0.0
BuildRequires: jboss-microcontainer2 >= 0:2.0.2
BuildRequires: jboss-common-core
BuildRequires: jboss-remoting >= 0:2.5.1
BuildRequires: jboss-security-spi >= 0:2.0.3
BuildRequires: jbosssx2 >= 0:2.0.3
BuildRequires: jbossws-parent >= 0:1.0.2
BuildRequires: jbossws-common >= 0:1.1.0-0.SP2.2
BuildRequires: jbossws-framework >= 0:0:3.1.2-1.SP4.1
BuildRequires: jbossws-spi >= 0:1.1.2-1.SP1.1
BuildRequires: jbossxb2
BuildRequires: jpackage-utils
BuildRequires: jbossweb-servlet-2.5-api
BuildRequires: juddi
BuildRequires: maven2-plugin-enforcer
BuildRequires: sun-fi
BuildRequires: tjws >= 0:1.3.3
BuildRequires: ws-scout
BuildRequires: wsdl4j >= 0:1.6.2
BuildRequires: wstx >= 0:3.2.6
BuildRequires: xalan-j2 >= 0:2.7.1
BuildRequires: xerces-j2 >= 0:2.8.1
BuildRequires: xml-security >= 0:1.4.2
BuildRequires: maven2
BuildRequires: maven2-plugin-antrun
BuildRequires: maven2-plugin-assembly
BuildRequires: maven2-plugin-compiler
BuildRequires: maven2-plugin-dependency
BuildRequires: maven2-plugin-install
BuildRequires: maven2-plugin-jar
BuildRequires: maven2-plugin-source
BuildRequires: maven2-plugin-release
BuildRequires: maven2-plugin-resources
BuildRequires: maven2-plugin-war
BuildRequires: maven-surefire-maven-plugin
BuildRequires: maven-surefire-provider-junit
BuildRequires: mojo-maven2-plugin-buildnumber
BuildRequires: xpp3-minimal

BuildRequires: jboss-jaxrpc-api_1.1_spec
BuildRequires: saaj_1_3_api
BuildRequires: ws_metadata_2_0_api

#Requires: ws_metadata_2_0_api
Requires:      jaxrpc_1_1_api
Requires:      jaxws_2_1_api       
Requires:      saaj_1_3_api
Requires:      ws_metadata_2_0_api

Requires:      wstx
Requires:      glassfish-jaf
Requires:      glassfish-jaxb
Requires:      glassfish-javamail
Requires:      jboss-common-core
Requires:      jboss-remoting
Requires:      jbossws-common >= 0:1.1.0-0.SP2.2
Requires:      jbossws-framework >= 0:0:3.1.2-1.SP4.1
Requires:      jbossws-spi >= 0:1.1.2-1.SP1.1
Requires:      jbossxb2
Requires:      jpackage-utils
Requires:      jbossweb
Requires:      wsdl4j
Requires:      xalan-j2
Requires:      xerces-j2
Requires:      xml-security

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArch:      noarch

%description
JBossWS an implementation of J2EE Web Services

%if %{with_repolib}
%package     repolib
Summary:     Artifacts to be uploaded to a repository library
Group:  Development/Libraries/Java

%description     repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -q -n %{name}-native-%{version_full}
%patch0 -b .sav0

%build
export JBOSS_HOME=%{_datadir}/jbossas
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL
mkdir -p ./output/reposave

mvn-jpp install:install-file -DgroupId=org.jboss.ws -DartifactId=jbossws-framework -Dversion=3.1.2.SP4 -Dclassifier=testsuite -Dpackaging=zip -Dfile=%{_javadir}/jbossws-framework-testsuite.zip -Dmaven.repo.local=$MAVEN_REPO_LOCAL

mvn-jpp \
        -e \
        -Djboss.repository=$(pwd)/repository \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=false \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Djboss.local.repository=./output/reposave \
        install


%install
rm -rf $RPM_BUILD_ROOT

# Install to javadir
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p modules/core/target/jbossws-native-core-%{version_full}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p modules/core/target/jbossws-native-core-%{version_full}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p modules/endorsed/target/jbossws-native-factories-%{version_full}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p modules/endorsed/target/jbossws-native-factories-%{version_full}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
# We cannot install it as an exploded war or maven will not retrieve it
#install -dm 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossws-native-management-%{version_full}.war
#cp -p modules/management/target/jbossws-native-management-%{version_full}.war $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossws-native-management-%{version_full}.war/
#(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossws-native-management-%{version_full}.war; jar xvf jbossws-native-management-%{version_full}.war; rm jbossws-native-management-%{version_full}.war)
cp -p modules/management/target/jbossws-native-management-%{version_full}.war  $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p modules/resources/target/jbossws-native-resources-%{version_full}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p modules/resources/target/jbossws-native-resources-%{version_full}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p modules/client/target/jbossws-native-client-%{version_full}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p modules/client/target/jbossws-native-client-%{version_full}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}

(cd $RPM_BUILD_ROOT%{_javadir}/%{name}
for jar in *-%{version_full}*.jar; do ln -sf ${jar} `echo ${jar} | sed "s|-%{version_full}||g"`;done
for war in *-%{version_full}*.war; do ln -sf ${war} `echo ${war} | sed "s|-%{version_full}||g"`;done)

# -repolib
%if %{with_repolib}

    # jboss/jbossws
    install -d -m 755 $RPM_BUILD_ROOT%{repodir}
    install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
    install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml

%{__sed} -i 's/@VERSION@/%{namedversion}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml


    install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
    install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}/
    install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}/

    cp -p modules/core/target/jbossws-native-core-%{version_full}.jar $RPM_BUILD_ROOT%{repodirlib}
    cp -p modules/core/target/jbossws-native-core-%{version_full}-sources.jar $RPM_BUILD_ROOT%{repodirlib}
    cp -p modules/endorsed/target/jbossws-native-factories-%{version_full}.jar $RPM_BUILD_ROOT%{repodirlib}
    cp -p modules/endorsed/target/jbossws-native-factories-%{version_full}-sources.jar $RPM_BUILD_ROOT%{repodirlib}
    cp -p modules/management/target/jbossws-native-management-%{version_full}.war $RPM_BUILD_ROOT%{repodirlib}
    cp -p modules/resources/target/jbossws-native-resources-%{version_full}.jar $RPM_BUILD_ROOT%{repodirlib}
    cp -p modules/resources/target/jbossws-native-resources-%{version_full}-sources.jar $RPM_BUILD_ROOT%{repodirlib}
    cp -p modules/client/target/jbossws-native-client-%{version_full}.jar $RPM_BUILD_ROOT%{repodirlib}
    cp -p modules/client/target/jbossws-native-client-%{version_full}-sources.jar $RPM_BUILD_ROOT%{repodirlib}

   (cd $RPM_BUILD_ROOT%{repodirlib}
   for jar in *-%{version_full}*.jar; do mv ${jar} `echo ${jar} | sed "s|-%{version_full}||g"`;done
   for war in *-%{version_full}*.war; do mv ${war} `echo ${war} | sed "s|-%{version_full}||g"`;done)

cp -p pom.xml $RPM_BUILD_ROOT%{repodirlib}/jbossws-native.pom
cp -p modules/core/pom.xml $RPM_BUILD_ROOT%{repodirlib}/jbossws-native-core.pom
cp -p modules/endorsed/pom.xml $RPM_BUILD_ROOT%{repodirlib}/jbossws-native-factories.pom
cp -p modules/management/pom.xml $RPM_BUILD_ROOT%{repodirlib}/jbossws-native-management.pom
cp -p modules/resources/pom.xml $RPM_BUILD_ROOT%{repodirlib}/jbossws-native-resources.pom
cp -p modules/client/pom.xml $RPM_BUILD_ROOT%{repodirlib}/jbossws-native-client.pom

%endif

%add_to_maven_depmap org.jboss.ws.native jbossws-native %{version_full} JPP/%{name} jbossws-native
%add_to_maven_depmap org.jboss.ws.native jbossws-native-core %{version_full} JPP/%{name} jbossws-native-core
%add_to_maven_depmap org.jboss.ws.native jbossws-native-factories %{version_full} JPP/%{name} jbossws-native-factories
%add_to_maven_depmap org.jboss.ws.native jbossws-native-management %{version_full} JPP/%{name} jbossws-native-management
%add_to_maven_depmap org.jboss.ws.native jbossws-native-resources %{version_full} JPP/%{name} jbossws-native-resources
%add_to_maven_depmap org.jboss.ws.native jbossws-native-client %{version_full} JPP/%{name} jbossws-native-client

%add_to_maven_depmap org.jboss.ws.native jbossws-native-jaxws %{version_full} JPP jaxws_2_1_api
%add_to_maven_depmap org.jboss.ws.native jbossws-native-saaj %{version_full} JPP saaj_1_3_api
%add_to_maven_depmap org.jboss.ws.native jbossws-native-jaxrpc %{version_full} JPP jaxrpc_1_1_api

%{__mkdir_p} $RPM_BUILD_ROOT%{_datadir}/maven2/poms
cp -p pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-native.pom
cp -p modules/core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-native-core.pom
cp -p modules/endorsed/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-native-factories.pom
cp -p modules/management/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-native-management.pom
cp -p modules/resources/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-native-resources.pom
cp -p modules/client/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}-native-client.pom

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*jar
%{_javadir}/%{name}/*war
%{_datadir}/maven2/poms/JPP.%{name}*.pom
%{_mavendepmapfragdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Tue Jul 05 2011 Fernando Nasser <fnasser@redhat.com> 0:3.1.2-6.SP10.1
- Upgrade to 3.1.2.SP10

* Tue May 10 2011 Yiqiao Wang <yiwang@redhat.com> 0:3.1.2-6.SP9.1
- Upgrade to 3.1.2.SP9

* Tue Apr 26 2011 Yiqiao Wang <yiwang@redhat.com> 0:3.1.2-5.SP8.6
- Apply jbossws-native-client-manifest.patch to change Class-Path of jaxrpc (JIRA 6319)

* Wed Mar 23 2011 Yiqiao Wang <yiwang@redhat.com> 0:3.1.2-5.SP8.1
- Upgrade to 3.1.2.SP8
- Sync with JB-EAP-5-RHEL-6 branch

* Tue Jul 20 2010 Yiqiao Wang <yiwang@redhat.com> - 0:3.1.2-4.SP7.1
- Upgrade to 3.1.2.SP7

* Thu May 27 2010 Yiqiao Wang <yiwang@redhat.com> - 0:3.1.2-4.SP6.1
- Upgrade to 3.1.2.SP6
- Add BR:  maven2-plugin-enforcer
- Add BR: wstx, add an depmap entry for it

* Fri May 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:3.1.2-3.SP3_CP01.4.1.1
- rebuilt

* Wed Apr 7 2010 Yiqiao Wang <yiwang@redhat.com> 3.1.2-2.SP3_CP01.4.1
- Rebuild

* Tue Mar 02 2010 Permaine Cheung <pcheung@redhat.com> 3.1.2-2.SP3_CP01.4
- Fix depmap for jboss-common-core

* Mon Mar 01 2010 Permaine Cheung <pcheung@redhat.com> 3.1.2-2.SP3_CP01.3
- BR and R jboss-common-core instead of jboss-common

* Fri Feb 26 2010 Permaine Cheung <pcheung@redhat.com> 3.1.2-2.SP3_CP01.2
- BR and R jbossxb instead of jbossxb2

* Mon Jan 25 2010 Martha Benitez <mbenitez@redhat.com> 3.1.2-3.SP3_CP01.1
- Upgrade to 3.1.2.SP3.CP01
- Add BR ws-scout, juddi

* Mon Sep 21 2009 Permaine Cheung <pcheung@redhat.com> 3.1.2-2.SP3_patch_02.2
- Use _patch_02 only in release tag in rpm, use -patch-02 in other places

* Fri Sep 18 2009 Permaine Cheung <pcheung@redhat.com> 3.1.2-2.SP3_patch_02.1
- Fix versions of dependencies in pom
- Add patch for JBPAPP-2825, and change location to 3.1.2.SP3-patch-02

* Fri Sep 11 2009 Fernando Naseer <fnasser@redhat.com> 3.1.2-1.SP3.patch01.3
- Do not install war exploded of maven won't grab it as an artifact

* Thu Sep 03 2009 Fernando Naseer <fnasser@redhat.com> 3.1.2-1.SP3.patch01.2
- Add poms to repolig lib directory, alongside with the corresponding JARs

* Thu Sep 03 2009 Fernando Naseer <fnasser@redhat.com> 3.1.2-1.SP3.patch01.1
- Patch for xmlsec 1.4.3

* Wed Jul 29 2009 Permaine Cheung <pcheung@redhat.com> 3.1.2-0.SP3.1
- Update to 3.1.2.SP3

* Mon Jul 27 2009 Permaine Cheung <pcheung@redhat.com> 3.1.2-0.SP1.5
- Rebuild with latest jboss-jaxr
- Fix pom names

* Mon Jul 27 2009 Permaine Cheung <pcheung@redhat.com> 3.1.2-0.SP1.4
- Rebuild with jboss-jaxr 1.2.1.GA

* Tue Jul 21 2009 Permaine Cheung <pcheung@redhat.com> 3.1.2-0.SP1.3
- Fix component-info.xml

* Tue Jul 21 2009 Permaine Cheung <pcheung@redhat.com> 3.1.2-0.SP1.2
- Rebuild

* Mon Jul 20 2009 Permaine Cheung <pcheung@redhat.com> 3.1.2-0.SP1.2
- Update to 3.1.2.SP2
- Build with maven

